## mingw-w64-quantum-espresso-7.3.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)
# CMake < 3.13 cannot install external targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2152

# CMake < 3.14 generates incorrect dependency graphs with
# alias targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2521

# CMake < 3.20 does not support NVHPC compiler id
# https://cmake.org/cmake/help/latest/release/3.20.html#compilers

# Policy CMP0048: The project() command manages VERSION variables
set(CMAKE_POLICY_DEFAULT_CMP0048 NEW)

project(qe
    VERSION 7.3.1
    DESCRIPTION "ESPRESSO: opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization"
    LANGUAGES Fortran C)

if(${qe_BINARY_DIR} STREQUAL ${qe_SOURCE_DIR})
    message(FATAL_ERROR "QE source folder cannot be safely used as a build folder!")
endif()

##########################################################
# Define the paths for static libraries and executables
##########################################################
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/lib 
    CACHE
    PATH "Single output directory for building all libraries.")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/bin 
    CACHE
    PATH "Single output directory for building all executables.")

###########################################################
# Build helpers
###########################################################
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include(cmake/qeHelpers.cmake)

###########################################################
# Build Type
# Ensure that a specific, default build type is set when
# none has been explicitly set by the user
###########################################################
qe_ensure_build_type("Release")

###########################################################
# Modules
###########################################################
include(CheckFunctionExists)
# Must use GNUInstallDirs to install libraries into correct
# locations on all platforms.
include(GNUInstallDirs)

###########################################################
# Build Options
###########################################################
include(CMakeDependentOption)
option(QE_ENABLE_CUDA
    "enable CUDA acceleration on NVIDIA GPUs" OFF)
if(QE_ENABLE_CUDA)
    option(QE_ENABLE_OPENACC "enable OpenACC acceleration" ON)
    # OpenMP enabled by default if CUDA is enable
    option(QE_ENABLE_OPENMP
        "enable distributed execution support via OpenMP" ON)
else()
    option(QE_ENABLE_OPENACC "enable OpenACC acceleration" OFF)
    option(QE_ENABLE_OPENMP
        "enable distributed execution support via OpenMP" OFF)
endif()
cmake_dependent_option(QE_ENABLE_OFFLOAD
    "enable OpenMP offload"
    OFF "QE_ENABLE_OPENMP" OFF)
option(QE_ENABLE_MPI
    "enable distributed execution support via MPI" ON)
option(QE_ENABLE_MPI_GPU_AWARE
    "enable GPU aware MPI operations" OFF)
option(QE_ENABLE_TEST
    "enable unit and system tests" ON)
cmake_dependent_option(QE_ENABLE_BENCHMARK
    "enable benchmark tests" OFF "QE_ENABLE_TEST" OFF)
option(QE_ENABLE_TRACE
    "enable execution tracing output" OFF)
option(QE_ENABLE_PROFILE_NVTX
        "enable execution of NVIDIA NVTX profiler plugin" OFF)
option(QE_ENABLE_MPI_INPLACE
    "enable inplace MPI calls (ignored when QE_ENABLE_MPI=OFF)" OFF)
option(QE_ENABLE_MPI_MODULE
    "use MPI via Fortran module instead of mpif.h header inclusion" OFF)
option(QE_ENABLE_BARRIER
    "enable global synchronization between execution units" OFF)
option(QE_LAPACK_INTERNAL
    "enable internal reference LAPACK" OFF)
option(QE_ENABLE_SCALAPACK
    "enable SCALAPACK execution units" OFF)
cmake_dependent_option(QE_ENABLE_SCALAPACK_QRCP
    "enable SCALAPACK QRCP in pw2wannier90 (requires SCALAPACK>=2.1.0 or Intel MKL>=2020)"
    OFF "QE_ENABLE_SCALAPACK" OFF)
option(QE_ENABLE_ELPA
    "enable ELPA execution units" OFF)
option(QE_ENABLE_LIBXC
    "enable LIBXC execution units" OFF)
option(QE_ENABLE_HDF5
    "enable HDF5 data collection" OFF)
option(QE_ENABLE_STATIC_BUILD
    "enable fully static build of executables" OFF)
option(QE_ENABLE_DOC
    "enable documentation building" OFF)
option(QE_CLOCK_SECONDS
    "print program time in seconds" OFF)
set(QE_FFTW_VENDOR "AUTO" CACHE
    STRING "select a specific FFTW library [Intel_DFTI, Intel_FFTW3, ArmPL, IBMESSL, FFTW3, Internal]")
set(QE_ENABLE_SANITIZER "none" CACHE STRING "none,asan,ubsan,tsan,msan")
set(QE_ENABLE_PLUGINS "" CACHE STRING "Semicolon-separated list of plugins")
set (QE_EXTRA_DEFINITIONS "" CACHE STRING "Semicolon-separated list of extra global definitions")
option(QE_ENABLE_FOX
    "enable XML I/O via Fox library" OFF)
if(QE_ENABLE_FOX)
    if(FOX_ROOT)
        set(QE_FOX_INTERNAL OFF)
    endif()
    option(QE_FOX_INTERNAL
        "enable FoX internal library" ON)
endif()

if(WANNIER90_ROOT)
    set(QE_WANNIER90_INTERNAL OFF)
endif()
option(QE_WANNIER90_INTERNAL
    "enable Wannier90 internal library" ON)
if(MBD_ROOT)
    set(QE_MBD_INTERNAL OFF)
endif()
option(QE_MBD_INTERNAL
    "enable LibMBD internal library" ON)
if(DEVICEXLIB_ROOT)
    set(QE_DEVICEXLIB_INTERNAL OFF)
endif()
option(QE_DEVICEXLIB_INTERNAL
    "enable DeviceXlib internal library" ON)
if(ENVIRON_ROOT)
    set(ENVIRON_DEFAULT "EXTERNAL")
else()
    set(ENVIRON_DEFAULT "NO")
endif()
set(QE_ENABLE_ENVIRON "${ENVIRON_DEFAULT}" CACHE
    STRING "select a specific Environ library [NO, EXTERNAL, INTERNAL]")

# OSCDFT
option(QE_ENABLE_OSCDFT "enable OS-CDFT 10.1021/acs.jctc.9b00281" OFF)


# TODO change all ifdefs throughout code base to match
# cmake options
# TODO symbols beginning with '__' followed by a capital
# character are reserved for standard library use (at
# least in C, not sure about Fortran), change all feature
# macros to avoid weird behaviors

if(QE_ENABLE_CUDA)
    qe_add_global_compile_definitions(__CUDA)
endif()
if(QE_ENABLE_TRACE)
    qe_add_global_compile_definitions(__TRACE)
endif()
if(QE_ENABLE_PROFILE_NVTX)
   qe_add_global_compile_definitions(__PROFILE_NVTX) 
endif() 
if(QE_ENABLE_MPI_INPLACE)
    qe_add_global_compile_definitions(__USE_INPLACE_MPI)
endif()
if(QE_ENABLE_MPI_MODULE)
    qe_add_global_compile_definitions(__MPI_MODULE)
endif()
if(QE_ENABLE_BARRIER)
    qe_add_global_compile_definitions(__USE_BARRIER)
endif()
foreach(DEF IN LISTS QE_EXTRA_DEFINITIONS)
    qe_add_global_compile_definitions(${DEF})
endforeach()
if(QE_ENABLE_MPI)
    # OMPI_SKIP_MPICXX: skip CXX APIs on openmpi, cause trouble to C APIs
    qe_add_global_compile_definitions(__MPI OMPI_SKIP_MPICXX)
    if(QE_ENABLE_MPI_GPU_AWARE)
        qe_add_global_compile_definitions(__GPU_MPI)
    endif()
endif()
if(QE_ENABLE_SCALAPACK)
    qe_add_global_compile_definitions(__SCALAPACK)
endif()
if(QE_ENABLE_HDF5)
    qe_add_global_compile_definitions(__HDF5)
endif()
if(QE_ENABLE_ENVIRON)
    qe_add_global_compile_definitions(__ENVIRON)
endif()
if(QE_CLOCK_SECONDS)
   qe_add_global_compile_definitions(__CLOCK_SECONDS)
endif()

# Feature checks
check_function_exists(mallinfo HAVE_MALLINFO)
if(HAVE_MALLINFO)
    qe_add_global_compile_definitions(HAVE_MALLINFO)
endif()

# OSCDFT
if(QE_ENABLE_OSCDFT)
    qe_add_global_compile_definitions(__OSCDFT)
endif()

# Check options consistency
if(QE_ENABLE_STATIC_BUILD AND BUILD_SHARED_LIBS)
    message(FATAL_ERROR "Full static build of QE executables requires static QE internal libraries. QE_ENABLE_STATIC_BUILD and BUILD_SHARED_LIBS cannot be both ON")
endif()
if(QE_ENABLE_ELPA AND NOT QE_ENABLE_SCALAPACK)
    message(FATAL_ERROR "ELPA requires SCALAPACK support, enable it with '-DQE_ENABLE_SCALAPACK=ON' or disable ELPA with '-DQE_ENABLE_ELPA=OFF'")
endif()
if(QE_ENABLE_SCALAPACK AND NOT QE_ENABLE_MPI)
    message(FATAL_ERROR "SCALAPACK requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable SCALAPACK with '-DQE_ENABLE_SCALAPACK=OFF'")
endif()
if(QE_ENABLE_CUDA AND NOT (CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"))
    message(FATAL_ERROR "NVHPC compiler is mandatory when CUDA is enabled due QE is based on CUDA Fortran language")
endif()
if(QE_ENABLE_OPENACC AND NOT (CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"))
    message(FATAL_ERROR "NVHPC compiler is mandatory when OpenACC is enabled")
endif()
if(QE_ENABLE_MPI_GPU_AWARE AND NOT (QE_ENABLE_CUDA AND QE_ENABLE_MPI))
    message(FATAL_ERROR "GPU aware MPI requires both MPI and CUDA features enabled")
endif()
# if(QE_ENABLE_HDF5 AND NOT QE_ENABLE_MPI)
#    message(FATAL_ERROR "HDF5 requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable HDF5 with '-DQE_ENABLE_HDF5=OFF'")
# endif()

# Add optional sanitizers ASAN, UBSAN, MSAN
set(VALID_SANITIZERS "none" "asan" "ubsan" "tsan" "msan")
# Perform sanitizer option check, only works in debug mode
if(NOT QE_ENABLE_SANITIZER IN_LIST VALID_SANITIZERS)
  message(FATAL_ERROR "Invalid -DQE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER}, value must be one of ${VALID_SANITIZERS}")
else()
  message(STATUS "Enable sanitizer QE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER}")
endif()
# only GNU works right now
if(NOT QE_ENABLE_SANITIZER STREQUAL "none" AND NOT CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  message(FATAL_ERROR "-DQE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER} only works with the GNU compiler")
endif()

# valid plugins checks
set(VALID_QE_PLUGINS "d3q" "pw2qmcpack" "gipaw" "legacy")
# Perform sanitizer option check, only works in debug mode
foreach(PLUGIN IN LISTS QE_ENABLE_PLUGINS)
  if(NOT PLUGIN IN_LIST VALID_QE_PLUGINS)
    message(FATAL_ERROR "Invalid QE plugin ${PLUGIN}, value must be one of \"${VALID_QE_PLUGINS}\".")
  else()
    message(STATUS "Enable QE plugin ${PLUGIN}")
  endif()
endforeach()

############################################################
# C preprocessor
# Note: reply on the compiler preprocessor whenever possible
############################################################
if(DEFINED ENV{CPP})
    set(QE_CPP_DEFAULT $ENV{CPP})
else()
    set(QE_CPP_DEFAULT cpp)
endif()
# QE_CPP_DEFAULT is only effective when cached QE_CPP doesn't exist.
set(QE_CPP ${QE_CPP_DEFAULT} CACHE
    STRING "C preprocessor for qe_preprocess_source in qeHelpers.cmake")
find_program(QE_CPP_FULL_PATH NAMES ${QE_CPP} DOC "C preprocessor full path")
if(QE_CPP_FULL_PATH)
    message(STATUS "C preprocessor used by qe_preprocess_source in qeHelpers.cmake: ${QE_CPP_FULL_PATH}")
else()
    set(QE_CPP_SAVED ${QE_CPP})
    unset(QE_CPP CACHE)
    message(FATAL_ERROR "C preprocessor ${QE_CPP_SAVED} not found. Pass a working one to CMake via QE_CPP!")
endif()

###########################################################
# language standard requirements
###########################################################
# TODO need to require all compilers using the same one
if(CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC")
    set(CMAKE_C_STANDARD 11)
    set(CMAKE_C_STANDARD_REQUIRED ON)
    set(CMAKE_C_EXTENSIONS OFF)
endif()

###########################################################
# check Fortran compiler -isystem option support
###########################################################
include(CheckFortranCompilerFlag)
check_fortran_compiler_flag("-isystem ." Fortran_ISYSTEM_SUPPORTED)
if(NOT Fortran_ISYSTEM_SUPPORTED AND NOT DEFINED CMAKE_NO_SYSTEM_FROM_IMPORTED)
  set(CMAKE_NO_SYSTEM_FROM_IMPORTED ON)
endif()

###########################################################
# OpenMP
# The following targets will be defined:
add_library(qe_openmp_fortran INTERFACE)
add_library(qe_openmp_c INTERFACE)
qe_install_targets(qe_openmp_fortran qe_openmp_c)
###########################################################
if(QE_ENABLE_OPENMP)
    find_package(OpenMP REQUIRED Fortran C)
    target_link_libraries(qe_openmp_fortran INTERFACE OpenMP::OpenMP_Fortran)
    target_link_libraries(qe_openmp_c INTERFACE OpenMP::OpenMP_C)

=== Makefile ===
# Copyright (C) 2001-2020 Quantum ESPRESSO Foundation
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License. See the file `License' in the root directory
# of the present distribution.

include make.inc

# execute a target irrespective of the presence of a file or directory 
# with the same name
.PHONY: install

default :
	@echo 'to install Quantum ESPRESSO, type at the shell prompt:'
	@echo '  ./configure [--prefix=]'
	@echo '  make [-j] target'
	@echo ' '
	@echo 'where target identifies one or multiple CORE PACKAGES:'
	@echo '  pw           basic code for scf, structure optimization, MD'
	@echo '  ph           phonon code, Gamma-only and third-order derivatives'
	@echo '  hp           calculation of the Hubbard parameters from DFPT'
	@echo '  pwcond       ballistic conductance'
	@echo '  neb          code for Nudged Elastic Band method'
	@echo '  pp           postprocessing programs'
	@echo '  pwall        same as "make pw ph pp pwcond neb"'
	@echo '  cp           CP code: Car-Parrinello molecular dynamics'
	@echo '  all_currents QEHeat code: energy flux and charge current'
	@echo '  tddfpt       time dependent dft code'
	@echo '  gwl          GW with Lanczos chains'
	@echo '  ld1          utilities for pseudopotential generation'
	@echo '  xspectra     X-ray core-hole spectroscopy calculations'
	@echo '  couple       Library interface for coupling to external codes'
	@echo '  epw          Electron-Phonon Coupling with Wannier functions'
	@echo '  kcw          KCW code: implementation of Koopmans functionals in primitive cell'
	@echo '  gui          Graphical User Interface'
	@echo '  all          same as "make pwall cp ld1 tddfpt xspectra hp"'
	@echo ' '
	@echo 'where target identifies one or multiple THIRD-PARTIES PACKAGES:'
	@echo '  gipaw        NMR and EPR spectra'
	@echo '  w90          Maximally localised Wannier Functions'
	@echo '  want         Quantum Transport with Wannier functions'
	@echo '  yambo        electronic excitations with plane waves'
	@echo '  d3q          general third-order code and thermal transport codes'
	@echo ' '
	@echo 'where target is one of the following suite operation:'
	@echo '  doc          build documentation'
	@echo '  links        create links to all executables in bin/'
	@echo '  install      copy all executables to PREFIX/bin/'
	@echo '               (works with "configure --prefix=PREFIX)"'
	@echo '  tar          create a tarball of the source tree'
	@echo '  depend       generate dependencies (make.depend files)'
	@if test -d GUI/; then \
		echo '  tar-gui      create a standalone PWgui tarball from the GUI sources'; \
		echo '  tar-qe-modes create a tarball for QE-modes (Emacs major modes for Quantum ESPRESSO)'; fi
	@echo '  clean        remove executables and objects'
	@echo '  veryclean    remove files produced by "configure" as well'
	@echo '  distclean    revert distribution to the original status'

###########################################################
# Main targets
###########################################################

# The syntax "( cd PW ; $(MAKE) TLDEPS= all || exit 1)" below
# guarantees that error code 1 is returned in case of error and make stops
# If "|| exit 1" is not present, the error code from make in subdirectories
# is not returned and make goes on even if compilation has failed

pw : pwlibs
	if test -d PW ; then \
	( cd PW ; $(MAKE) TLDEPS= all || exit 1) ; fi

cp : bindir mods
	if test -d CPV ; then \
	( cd CPV ; $(MAKE) TLDEPS= all || exit 1) ; fi

ph : phlibs
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) TLDEPS= all || exit 1) ; fi

hp : hplibs
	if test -d HP; then \
	( cd HP; $(MAKE) TLDEPS= all || exit 1) ; fi

neb : pwlibs
	if test -d NEB; then \
	( cd NEB; $(MAKE) TLDEPS= all || exit 1) ; fi

tddfpt : lrmods
	if test -d TDDFPT; then \
	( cd TDDFPT; $(MAKE) TLDEPS= all || exit 1) ; fi

pp : pwlibs
	if test -d PP ; then \
	( cd PP ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

pwcond : pwlibs
	if test -d PWCOND ; then \
	( cd PWCOND ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

acfdt : phlibs
	if test -d ACFDT ; then \
	( cd ACFDT ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

gwl : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

gipaw : pwlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

d3q : phlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

ld1 : bindir mods
	if test -d atomic ; then \
	( cd atomic ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

xspectra : pwlibs
	if test -d XSpectra ; then \
	( cd XSpectra ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

couple : pw cp
	if test -d COUPLE ; then \
	( cd COUPLE ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

epw: phlibs w90lib
	if test -d EPW ; then \
	( cd EPW ; $(MAKE) all || exit 1; \
		cd ../bin; ln -fs ../EPW/bin/epw.x . ); fi

all_currents:
	if test -d QEHeat ; then \
	( cd QEHeat ; $(MAKE) all || exit 1; ) ; fi

travis : pwall epw
	if test -d test-suite ; then \
	( cd test-suite ; make run-travis || exit 1 ) ; fi

kcw : pwlibs lrmods pp w90lib
	if test -d KCW ; then \
	( cd KCW ; $(MAKE) all || exit 1 ) ; fi

gui : bindir
	@if test -d GUI/PWgui ; then \
	    cd GUI/PWgui ; \
	    $(MAKE) TLDEPS= init; \
	    echo ; \
	    echo "  ------------------------------------------------------------"; \
	    echo "  PWgui was built in ./GUI/PWgui/ and a link was made in bin/."; \
	    echo "  ------------------------------------------------------------"; \
	    echo "  Try it either as:  "; \
	    echo "         ./GUI/PWgui/pwgui" ; \
	    echo "     or"; \
	    echo "         ./bin/pwgui";\
	    echo ; \
	else \
	    echo ; \
	    echo "  Sorry, GUI/PWgui directory does not exist !" ; \
	    echo ; \
	fi

pwall : pw neb ph pp pwcond acfdt

all   : pwall cp ld1 tddfpt hp xspectra gwl kcw

###########################################################
# Auxiliary targets used by main targets:
# compile modules, libraries, directory for binaries, etc
###########################################################

pwlibs: bindir mods libks_solvers dftd3
	if test -d PW ; then \
	( cd PW ; $(MAKE) pw-lib || exit 1) ; fi

phlibs: pwlibs lrmods
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) ph-lib || exit 1) ; fi

hplibs: pwlibs lrmods
	if test -d HP; then \
	( cd HP; $(MAKE) hp-lib || exit 1) ; fi

gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) gwwa || exit 1 ) ; fi

pw4gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) pw4gwwa || exit 1 ) ; fi

mods : $(FOX) libutil libla libfft libupf libmbd librxc
	( cd Modules ; $(MAKE) TLDEPS= all || exit 1 )

libks_solvers : libutil libla
	( cd KS_Solvers ; $(MAKE) TLDEPS= all || exit 1 )

libla : $(LAPACK) libutil libcuda
	( cd LAXlib ; $(MAKE) TLDEPS= all || exit 1 )

libfft : 
	( cd FFTXlib ; $(MAKE) TLDEPS= all || exit 1 )

librxc : 
	( cd XClib ; $(MAKE) TLDEPS= all || exit 1 )

libutil : 
	( cd UtilXlib ; $(MAKE) TLDEPS= all || exit 1 )

libupf : libutil libcuda
	( cd upflib ; $(MAKE) TLDEPS= all || exit 1 )

lrmods : mods pwlibs
	( cd LR_Modules ; $(MAKE) TLDEPS= all || exit 1 )

dftd3 : mods
	( cd dft-d3 ; $(MAKE) TLDEPS= all || exit 1 )

bindir :
	test -d bin || mkdir bin

#############################################################
# Targets for external libraries
############################################################

liblapack: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libfox: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libcuda: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libmbd:
	cd install ; $(MAKE) -f extlibs_makefile $@

#########################################################
# plugins
#########################################################

w90: w90lib
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

w90lib: bindir $(LAPACK)
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

want: $(LAPACK)
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

yambo: $(LAPACK)
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

#########################################################
# "make links" produces links to all executables in bin/
#########################################################

# Contains workaround for name conflicts (dos.x and bands.x) with WANT
links : bindir
	( cd bin/ ; \
	rm -f *.x ; \
	for exe in ../*/*/*.x ../*/bin/* ; do \
	    if test ! -L $$exe ; then ln -fs $$exe . ; fi \
	done ; \
	[ -f ../WANT/wannier/dos.x ] && \
		ln -fs ../WANT/wannier/dos.x ../bin/dos_want.x ; \
	[ -f ../PP/src/dos.x ] &&  \
		ln -fs ../PP/src/dos.x ../bin/dos.x ; \
	[ -f ../WANT/wannier/bands.x ] && \
		ln -fs ../WANT/wannier/bands.x ../bin/bands_want.x ; \
	[ -f ../PP/src/dos.x ] &&  ln -fs ../PP/src/bands.x ../bin/bands.x ; \
	)

#############################################################
# 'make install' works with "configure --prefix=PREFIX"
# - If the PREFIX/bin directory does not exists it creates it
#############################################################

install : 
	mkdir -p $(PREFIX)/bin ; \
	for x in `find * ! -path "test-suite/*" -name *.x -type f` ; do \
		cp -v $$x $(PREFIX)/bin/ ; done
	@echo -e '\nQuantum ESPRESSO binaries are installed in $(PREFIX)/bin\n'

#########################################################
# Other targets: clean up
#########################################################

# remove object files and executables
clean : 
	touch make.inc 
	for dir in \
		CPV LAXlib FFTXlib XClib UtilXlib upflib Modules PP PW EPW KS_Solvers \
		NEB ACFDT COUPLE GWW XSpectra PWCOND dft-d3 \
		atomic LR_Modules upflib \
		dev-tools extlibs Environ TDDFPT PHonon HP GWW Doc GUI \
		QEHeat KCW \
	; do \
	    if test -d $$dir ; then \
		( cd $$dir ; \
		$(MAKE) TLDEPS= clean ) \
	    fi \
	done
	- @(cd install ; $(MAKE) -f plugins_makefile clean)
	- @(cd install ; $(MAKE) -f extlibs_makefile clean)
	- /bin/rm -rf bin/*.x tempdir

# remove files produced by "configure" as well
veryclean : clean
	- @(cd install ; $(MAKE) -f plugins_makefile veryclean)
	- @(cd install ; $(MAKE) -f extlibs_makefile veryclean)
	- (cd install ; rm -rf config.log configure.msg config.status \
		configure.h make_wannier90.inc autom4te.cache )
	- (cd include; rm -rf configure.in qe_cdefs.h )
	- rm -f espresso.tar.gz
	- rm -rf make.inc
	- rm -rf FoX
	- rm -rf MBD 
# remove everything not in the original distribution
distclean : veryclean
	- cd pseudo; ./clean_ps ; cd -
	- (cd install ; $(MAKE) -f plugins_makefile $@)
	- git submodule deinit --all --force # place deinit at the very end such that makefiles clean up as much as possible.

tar :
	@if test -f espresso.tar.gz ; then /bin/rm espresso.tar.gz ; fi
	# do not include unneeded stuff 
	find ./ -type f | grep -v -e /.svn/ -e'/\.' -e'\.o$$' -e'\.mod$$'\
		-e /.git/ -e'\.a$$' -e'\.d$$' -e'\.i$$' -e'_tmp\.f90$$' -e'\.x$$' \
		-e'~$$' -e'\./GUI' -e '\./tempdir' | xargs tar rvf espresso.tar
	gzip espresso.tar

#########################################################
# Tools for the developers
#########################################################
tar-gui :
	@if test -d GUI/PWgui ; then \
	    cd GUI/PWgui ; \
	    $(MAKE) TLDEPS= clean init pwgui-source; \
	    mv PWgui-*.tgz ../.. ; \
	else \
	    echo ; \
	    echo "  Sorry, tar-gui works only for git sources !!!" ; \
	    echo ; \
	fi

tar-qe-modes :
	@if test -d GUI/QE-modes ; then \
	    cd GUI/QE-modes ; \
	    $(MAKE) TLDEPS= veryclean tar; \
	    mv QE-modes-*.tar.gz ../.. ; \
	else \
	    echo ; \
	    echo "  Sorry, tar-qe-modes works only for git sources !!!" ; \
	    echo ; \
	fi

# NOTICE about "make doc": in order to build the .html and .txt
# documentation in Doc, "tcl", "tcllib", "xsltproc" are needed;
# in order to build the .pdf files in Doc, "pdflatex" is needed;
# in order to build html files for the user guide,
# "latex2html" and "convert" (from Image-Magick) are needed.
doc : 
	if test -d Doc ; then \

=== CPV/Makefile ===
# Makefile for CPV
sinclude ../make.inc

default: all

all:
	( cd src ; $(MAKE) all || exit 1 )

clean :
	( cd src ; $(MAKE) clean )

doc:
	(cd Doc ; $(MAKE) all || exit 1 )

doc_clean:
	(cd Doc ; $(MAKE) clean )

distclean: clean doc_clean

=== Doc/CMakeLists.txt ===
include(UseLATEX)

# By default the manuals are generated and installed in pdf format
# To generat the manuals use the following command: make pdf

# It is possible to generate user_guide
# in HTML format with the following command: make html

set(LATEX_DEFAULT_BUILD "pdf")

add_latex_document(
    user_guide.tex
    INPUTS quote.tex html.sty
    IMAGES quantum_espresso.png)

add_latex_document(
    constraints_HOWTO.tex
    FORCE_PDF)

add_latex_document(
    brillouin_zones.tex
    IMAGE_DIRS images
    FORCE_PDF)

add_latex_document(
    plumed_quick_ref.tex
    IMAGE_DIRS pic
    FORCE_PDF)

install(
    FILES
        ${PROJECT_BINARY_DIR}/Doc/user_guide.pdf 
        ${PROJECT_BINARY_DIR}/Doc/constraints_HOWTO.pdf
        ${PROJECT_BINARY_DIR}/Doc/brillouin_zones.pdf
        ${PROJECT_BINARY_DIR}/Doc/plumed_quick_ref.pdf
    DESTINATION 
        share/Doc)

=== EPW/CMakeLists.txt ===
set(sources
    src/epwcom.f90
    src/constants_epw.f90
    src/elph2.f90
    src/io_var.f90
    src/low_lvl.f90
    src/division.f90
    src/rigid_epw.f90
    src/io_epw.f90
    src/io_transport.f90
    src/io_selfen.f90
    src/wigner.f90
    src/wan2bloch.f90
    src/cum_mod.f90
    src/close_epw.f90
    src/poolgathering.f90
    src/printing.f90
    src/kfold.f90
    src/dynmat_asr.f90
    src/io_eliashberg.f90
    src/utilities.f90
    src/eliashbergcom.f90
    src/supercond.f90
    src/supercond_iso.f90
    src/supercond_aniso.f90
    src/grid.f90
    src/rotate.f90
    src/transport.f90
    src/transport_iter.f90
    src/pw2wan2epw.f90
    src/wannierization.f90
    src/indabs.f90
    src/bcast_epw_input.f90
    src/bloch2wan.f90
    src/dvqpsi.f90
    src/eliashberg.f90
    src/elphel2_shuffle.f90
    src/elphon_shuffle.f90
    src/elphon_shuffle_wrap.f90
    src/selfen.f90
    src/spectral_func.f90
    src/ephwann_shuffle.f90
    src/epw_init.f90
    src/epw_readin.f90
    src/epw_setup.f90
    src/epw_summary.f90
    src/loadumat.f90
    src/stop_epw.f90
    src/wannierEPW.f90
    src/loadbm.f90
    src/bfield.f90
    src/io_indabs.f90
    src/polaron.f90
    src/qdabs.f90
    src/wfpt_mod.f90
    src/rotate_wavefunction.f90
    src/selfen_ahc.f90
    src/read_ahc_files.f90
    )

qe_add_library(qe_epw ${sources})
target_link_libraries(
    qe_epw
    PRIVATE qe_wannier90
            qe_modules
            qe_lr_modules
            qe_phonon_ph
            qe_pw
            qe_mpi_fortran
            qe_upflib
            qe_fftx
            qe_elpa
            qe_xclib)

###########################################################
# epw.x
###########################################################
set(sources src/epw.f90)
qe_add_executable(qe_epw_exe ${sources})
set_target_properties(qe_epw_exe PROPERTIES OUTPUT_NAME epw.x)
target_link_libraries(qe_epw_exe PRIVATE qe_modules qe_pw qe_fftx qe_epw qe_upflib)

###########################################################
# ZG.x
###########################################################
set(sources ZG/src/ZG.f90)
qe_add_executable(qe_zg_exe ${sources})
set_target_properties(qe_zg_exe PROPERTIES OUTPUT_NAME ZG.x)
target_link_libraries(qe_zg_exe PRIVATE qe_modules qe_pw qe_phonon_ph qe_lr_modules qe_lapack)

###########################################################
# disca.x
###########################################################
set(sources ZG/src/disca.f90)
qe_add_executable(qe_zg_disca_exe ${sources})
set_target_properties(qe_zg_disca_exe PROPERTIES OUTPUT_NAME disca.x)
target_link_libraries(qe_zg_disca_exe PRIVATE qe_modules qe_pw qe_phonon_ph qe_lr_modules qe_lapack)

###########################################################
# pp_disca.x
###########################################################
set(sources ZG/src/pp_disca.f90)
qe_add_executable(qe_zg_pp_disca_exe ${sources})
set_target_properties(qe_zg_pp_disca_exe PROPERTIES OUTPUT_NAME pp_disca.x)
target_link_libraries(qe_zg_pp_disca_exe PRIVATE qe_modules qe_lr_modules qe_lapack)

###########################################################
# bands_unfold.x
###########################################################
set(src_bands_unfold_x ZG/src/bands_unfold.f90)
qe_add_executable(qe_zg_bands_unfold_exe ${sources})
set_target_properties(qe_zg_bands_unfold_exe PROPERTIES OUTPUT_NAME bands_unfold.x)
target_link_libraries(qe_zg_bands_unfold_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################
# pp_spctrlfn.x
###########################################################
set(sources ZG/src/pp_spctrlfn.f90)
qe_add_executable(qe_zg_pp_spctrlfn_exe ${sources})
set_target_properties(qe_zg_pp_spctrlfn_exe PROPERTIES OUTPUT_NAME pp_spctrlfn.x)
target_link_libraries(qe_zg_pp_spctrlfn_exe PRIVATE qe_modules qe_lr_modules qe_lapack)

###########################################################
# epsilon_Gaus.x
###########################################################
set(src_epsilon_Gaus_x ZG/src/epsilon_Gaus.f90)
qe_add_executable(qe_zg_epsilon_Gaus_exe ${sources})
set_target_properties(qe_zg_epsilon_Gaus_exe PROPERTIES OUTPUT_NAME epsilon_Gaus.x)
target_link_libraries(qe_zg_epsilon_Gaus_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################

qe_install_targets(
    # Libraries
    qe_epw
    # Exacutables
    qe_epw_exe qe_zg_exe qe_zg_disca_exe qe_zg_pp_disca_exe qe_zg_bands_unfold_exe qe_zg_pp_spctrlfn_exe qe_zg_epsilon_Gaus_exe)

install(PROGRAMS bin/pp.py TYPE BIN RENAME epw_pp.py)

add_custom_target(epw
    DEPENDS
        qe_epw_exe
    COMMENT
        "electron-Phonon Coupling with wannier functions")

=== EPW/Makefile ===

default: epw

all: epw

epw: 
	(cd src ; make all )
	- (mkdir -p bin)
	(cd bin ; ln -fs ../src/epw.x . )
	(cd ZG/src ; make )

clean:
	cd src ; rm -f *.o *.a *.mod  *~ *.F90
	cd ZG/src ; rm -f *.o *.a *.mod  *~

distclean : clean
	rm -f src/epw.x bin/epw.x
	rm -f ZG/src/*.x

release:
	cd ../ ; cp -r EPW EPW-release; cd EPW-release ; \
	rm -f src/*.o src/*.mod src/*.F90 src/*~ ; \
	rm bin/*.x ; \
	rm -rf examples/*/epw/out/* examples/*/epw/tmp/* \
	 examples/*/phonons/out/* examples/*/phonons/tmp/* \
	 examples/*/phonons/save/* ; \
	cd .. ; tar cfz EPW/EPW-release.tgz EPW-release ; \
	rm -rf EPW-release ; cd EPW

=== FFTXlib/Makefile ===
# Makefile for FFTXLIB
sinclude ../make.inc

default: all

all: fftx

fftx:
	( cd src ; $(MAKE) all || exit 1 )

fftx_clean:
	( cd src ; $(MAKE) clean )

clean: fftx_clean

distclean: clean

=== GUI/CMakeLists.txt ===
install(DIRECTORY Guib PWgui QE-modes
    DESTINATION
        share/GUI
    USE_SOURCE_PERMISSIONS)

install(FILES README
    DESTINATION
        share/GUI)

install(CODE
    "execute_process(
        COMMAND make init
        WORKING_DIRECTORY ${CMAKE_INSTALL_PREFIX}/share/GUI/PWgui
        OUTPUT_QUIET
        ERROR_QUIET)")

=== GWW/CMakeLists.txt ===
set(src_gww
    gww/basic_structures.f90
    gww/compact_product.f90
    gww/contour.f90
    gww/create_hf.f90
    gww/create_quasi_particle.f90
    gww/create_quasi_particle_off.f90
    gww/do_contour.f90
    gww/do_polarization_lanczos.f90
    gww/do_self_lanczos.f90
    gww/do_self_lanczos_time.f90
    gww/do_self_lanczos_full.f90
    gww/energies_gww.f90
    gww/expansion.f90
    gww/fft_gw.f90
    gww/fit_multipole.f90
    gww/fit_polynomial.f90
    gww/go_dressed_w.f90
    gww/go_exchange.f90
    gww/go_fft.f90
    gww/go_green.f90
    gww/go_polarization.f90
    gww/green_function.f90
    gww/gv_time.f90
    gww/input_gw.f90
    gww/lanczos_polarization.f90
    gww/para_gww.f90
    gww/polarization.f90
    gww/read_data_pw.f90
    gww/self_energy.f90
    gww/self_energy_storage.f90
    gww/start_end.f90
    gww/times_gw.f90
    gww/vcprim.f90)

set(src_pw4gww
    pw4gww/allocate_wannier.f90
    pw4gww/produce_wannier_gamma.f90
    pw4gww/start_pw4gww.f90
    pw4gww/stop_pp.f90
    pw4gww/openfil_pw4gww.f90
    pw4gww/dft_exchange.f90
    pw4gww/wfc_real.f90
    pw4gww/full.f90
    pw4gww/energies_xc.f90
    pw4gww/wannier.f90
    pw4gww/write_wannier_matrix.f90
    pw4gww/rotate_wannier.f90
    pw4gww/self_lanczos.f90
    pw4gww/pola_lanczos.f90
    pw4gww/matrix_wannier_gamma.f90
    pw4gww/calculate_wing.f90
    pw4gww/fake_conduction.f90
    pw4gww/o_1psi.f90
    pw4gww/o_bands.f90
    pw4gww/optimal.f90
    pw4gww/pola_partial.f90
    pw4gww/semicore.f90
    pw4gww/semicore_read.f90
    pw4gww/v_basis.f90
    pw4gww/wannier_uterms.f90
    pw4gww/write_vpot_matrix.f90
    pw4gww/diago_cg.f90
    pw4gww/o_rinitcgg.f90
    pw4gww/diago_cg_g.f90
    pw4gww/contour_terms.f90
    pw4gww/fft_custom.f90
    pw4gww/exchange_custom.f90
    pw4gww/mp_wave_parallel.f90
    pw4gww/wannier_bse.f90
    pw4gww/hpsi_pw4gww.f90
    pw4gww/cgsolve_all_gamma.f90
    pw4gww/gww_realus.f90
    pw4gww/operator_1_vp.f90
    pw4gww/operator_debug.f90
    pw4gww/lanczos_chains.f90
    pw4gww/convergence.f90
    pw4gww/easy_gw.f90)
qe_enable_cuda_fortran("${src_pw4gww}")

set(src_bse
    bse/openfil_bse.f90
    bse/start_bse.f90
    bse/bse_wannier.f90
    bse/transitions.f90
    bse/read_export.f90
    bse/bse_basic_structure.f90
    bse/exciton.f90
    bse/diago_exc.f90
    bse/exchange_exc.f90
    bse/rotate_wannier.f90
    bse/write_wannier_matrix.f90
    bse/direct_v_exc.f90
    bse/direct_w_exc.f90
    bse/direct_www.f90
    bse/exc_h_a.f90
    bse/sdescent.f90
    bse/check_basis.f90
    bse/conjgrad.f90
    bse/conj_grad_stuff.f90
    bse/find_eig.f90
    bse/plot_excwfn.f90
    bse/tspace.f90
    bse/absorption.f90
    bse/spectrum.f90
    bse/absorption.f90
    bse/cgsolve.f90
    bse/h_h.f90
    bse/dvpsi_bse.f90
    bse/lanczos.f90
    bse/print_spectrum.f90
    bse/print_bse.f90
    bse/contract_w_exc.f90
    bse/qpe_exc.f90
    bse/qpcorrections.f90)

set(src_head
    head/bcast_gwl_input.f90
    head/close_gwl.f90
    head/lanczos_k.f90
    head/openfilq_gwl.f90
    head/gwl_readin.f90
    head/solve_head.f90)

set(src_minpack
    minpack/dpmpar.f90
    minpack/fdjac2.f90
    minpack/lmder1.f90
    minpack/lmdif1.f90
    minpack/mlagzo.f90
    minpack/qrfac.f90
    minpack/test.f90
    minpack/enorm.f90
    minpack/lmder.f90
    minpack/lmdif.f90
    minpack/lmpar.f90
    minpack/mlegzo.f90
    minpack/qrsolv.f90)

set(src_simple
    simple/stop_pp.f90
    simple/read_export.f90
    simple/openfile_simple.f90
    simple/input_simple.f90
    simple/wfc_basis.f90
    simple/product_basis.f90
    simple/v_product.f90
    simple/epe.f90
    simple/gk_sort_limit.f90
    simple/khamiltonian.f90
    simple/commutator.f90)

set(src_simple_bse
    simple_bse/simple_object.f90
    simple_bse/start_end.f90
    simple_bse/input_simple_exc.f90
    simple_bse/simple_eigen.f90
    simple_bse/diago_exc_sd.f90
    simple_bse/hamiltonian.f90
    simple_bse/derived_object.f90
    simple_bse/diago_exc_cg.f90
    simple_bse/spectrum.f90
    simple_bse/lanczos.f90
    simple_bse/build_eemat.f90)

set(src_simple_ip
    simple_ip/simple_ip_objects.f90
    simple_ip/start_end.f90
    simple_ip/input_simple_ip.f90
    simple_ip/tetra_mod1.f90
    simple_ip/interpolation.f90
    simple_ip/diagonalization.f90
    simple_ip/dielectric.f90)

qe_add_library(qe_gww ${src_gww})
target_link_libraries(qe_gww
    PRIVATE
        qe_gww_minpack
        qe_fftx
        qe_modules)

qe_add_library(qe_gww_pw4gww ${src_pw4gww})
target_link_libraries(qe_gww_pw4gww
    PRIVATE
        qe_scalapack
        qe_pw
        qe_modules
        qe_gww
        qe_utilx
        qe_fftx
        qe_upflib
        qe_lax
        qe_gww_minpack
        qe_xclib)

qe_add_library(qe_gww_bse ${src_bse})
target_link_libraries(qe_gww_bse
    PRIVATE
        qe_pw
        qe_modules
        qe_gww
        qe_gww_pw4gww
        qe_upflib
        qe_fftx
        qe_xclib)

qe_add_library(qe_gww_head ${src_head})
target_link_libraries(qe_gww_head
    PRIVATE
        qe_pw
        qe_lr_modules
        qe_modules
        qe_phonon_ph
        qe_upflib
        qe_fftx
        qe_xclib)

qe_add_library(qe_gww_minpack ${src_minpack})
target_link_libraries(qe_gww_minpack
    PRIVATE
        qe_modules)

qe_add_library(qe_gww_simple ${src_simple})
target_link_libraries(qe_gww_simple
    PRIVATE
        qe_pw
        qe_gww
        qe_modules
        qe_upflib
        qe_fftx
        qe_xclib)

qe_add_library(qe_gww_simplebse ${src_simple_bse})
target_link_libraries(qe_gww_simplebse
    PRIVATE
        qe_modules)

qe_add_library(qe_gww_simpleip ${src_simple_ip})
target_link_libraries(qe_gww_simpleip
    PRIVATE
        qe_modules
        qe_pw)

###########################################################
# graph.x
###########################################################
set(src_graph_x util/graph.f90)
qe_add_executable(qe_gww_util_grap_exe ${src_graph_x})
set_target_properties(qe_gww_util_grap_exe
    PROPERTIES
        OUTPUT_NAME graph.x)
set_target_properties(qe_gww_util_grap_exe
    PROPERTIES
        OUTPUT_NAME graph.x)

###########################################################
# abcoeff_to_eps.x
###########################################################
set(src_abcoeff_to_eps_x util/abcoeff_to_eps.f90)
qe_add_executable(qe_gww_util_abcoefftoeps_exe ${src_abcoeff_to_eps_x})
set_target_properties(qe_gww_util_abcoefftoeps_exe
    PROPERTIES
        OUTPUT_NAME abcoeff_to_eps.x)
set_target_properties(qe_gww_util_abcoefftoeps_exe
    PROPERTIES
        OUTPUT_NAME abcoeff_to_eps.x)

###########################################################
# memory_pw4gww.x
###########################################################
set(src_memory_pw4gww_x util/memory_pw4gww.f90)
qe_add_executable(qe_gww_util_memorypw4gww_exe ${src_memory_pw4gww_x})
set_target_properties(qe_gww_util_memorypw4gww_exe
    PROPERTIES
        OUTPUT_NAME memory_pw4gww.x)
set_target_properties(qe_gww_util_memorypw4gww_exe
    PROPERTIES
        OUTPUT_NAME memory_pw4gww.x)

#############################################################
# bse_main.x
############################################################
set(src_bse_main_x bse/bse_main.f90)
qe_add_executable(qe_gww_bse_bse_main_exe ${src_bse_main_x})
set_target_properties(qe_gww_bse_bse_main_exe
    PROPERTIES
        OUTPUT_NAME bse_main.x)
target_link_libraries(qe_gww_bse_bse_main_exe
    PRIVATE
       qe_gww_bse
       qe_gww_pw4gww
       qe_gww_minpack
       qe_modules
       qe_pw
       qe_upflib
       qe_fftx
       qe_xclib)

################################################################
# gww.x
################################################################
set(src_gww_x gww/gww.f90)
qe_add_executable(qe_gww_gww_exe ${src_gww_x})
set_target_properties(qe_gww_gww_exe
    PROPERTIES
        OUTPUT_NAME gww.x)
target_link_libraries(qe_gww_gww_exe
    PRIVATE
       qe_gww
       qe_gww_minpack
       qe_pw
       qe_modules)

################################################################
# gww_fit.x
################################################################
set(src_gww_fit_x gww/gww_fit.f90)
qe_add_executable(qe_gww_gww_fit_exe  ${src_gww_fit_x})
set_target_properties(qe_gww_gww_fit_exe
    PROPERTIES
        OUTPUT_NAME gww_fit.x)
target_link_libraries(qe_gww_gww_fit_exe
    PRIVATE
       qe_gww
       qe_gww_minpack
       qe_modules)

################################################################
# head.x
################################################################
set(src_head_x head/head.f90)
qe_add_executable(qe_gww_head_exe ${src_head_x})
set_target_properties(qe_gww_head_exe
    PROPERTIES
        OUTPUT_NAME head.x)
target_link_libraries(qe_gww_head_exe
    PRIVATE
       qe_gww_head
       qe_gww_minpack
       qe_phonon_ph
       qe_modules
       qe_pw)

###########################################################
# simple.x
###########################################################
set(src_simple_x simple/simple.f90)
qe_add_executable(qe_gww_simple_exe ${src_simple_x})
set_target_properties(qe_gww_simple_exe
    PROPERTIES
        OUTPUT_NAME simple.x)
target_link_libraries(qe_gww_simple_exe
    PRIVATE
        qe_gww_simple
        qe_fftx
        qe_xclib
        qe_pw
        qe_upflib
        qe_modules)

###########################################################
# simple_bse.x
###########################################################
set(src_simple_bse_x simple_bse/simple_bse.f90)
qe_add_executable(qe_gww_simple_bse_exe ${src_simple_bse_x})
set_target_properties(qe_gww_simple_bse_exe
    PROPERTIES
        OUTPUT_NAME simple_bse.x)
target_link_libraries(qe_gww_simple_bse_exe
    PRIVATE
        qe_gww_simplebse
        qe_upflib
        qe_modules)

###############################################################
# simple_ip.x
################################################################
set(src_simple_ip_x simple_ip/simple_ip.f90)
qe_add_executable(qe_gww_simple_ip_exe ${src_simple_ip_x})
set_target_properties(qe_gww_simple_ip_exe
    PROPERTIES
        OUTPUT_NAME simple_ip.x)
target_link_libraries(qe_gww_simple_ip_exe
    PRIVATE
        qe_gww_simpleip
        qe_modules)

################################################################
# pw4gww.x
################################################################
set(src_pw4gww_pw4gww_x pw4gww/pw4gww.f90)
qe_add_executable(qe_gww_pw4gww_exe  ${src_pw4gww_pw4gww_x})
set_target_properties(qe_gww_pw4gww_exe
    PROPERTIES
        OUTPUT_NAME pw4gww.x)
target_link_libraries(qe_gww_pw4gww_exe
    PRIVATE
        qe_gww_pw4gww
        qe_phonon_gamma
        qe_fftx
        qe_xclib
        qe_pw
        qe_modules)

###########################################################

set(GWW_EXE_TARGETS
    qe_gww_pw4gww_exe
    qe_gww_util_grap_exe
    qe_gww_util_abcoefftoeps_exe
    qe_gww_util_memorypw4gww_exe
    qe_gww_bse_bse_main_exe
    qe_gww_gww_exe
    qe_gww_gww_fit_exe
    qe_gww_head_exe
    qe_gww_simple_exe
    qe_gww_simple_bse_exe
    qe_gww_simple_ip_exe)

qe_install_targets(
    # Libraries
    qe_gww
    qe_gww_pw4gww
    qe_gww_bse
    qe_gww_head
    qe_gww_minpack
    qe_gww_simple
    qe_gww_simplebse
    qe_gww_simpleip
    # Executables
    ${GWW_EXE_TARGETS})

add_custom_target(gwl
    DEPENDS
        ${GWW_EXE_TARGETS}
    COMMENT
        "GW with Lanczos chains")

=== KCW/CMakeLists.txt ===
add_subdirectory(src)
add_subdirectory(PP)

###########################################################

qe_install_targets(qe_kcw qe_kcw_exe qe_kcwpp_sh_exe qe_kcwpp_interp_exe)

add_custom_target(
    kcw
    DEPENDS pw qe_pp_pw2wannier90_exe w90 qe_kcw_exe qe_kcwpp_sh_exe qe_kcwpp_interp_exe
    COMMENT "Koopmans spectral functionals")

=== KS_Solvers/CMakeLists.txt ===
set(ks_headers
  ks_solver_interfaces.h)
set (ks_include_dir ${CMAKE_CURRENT_BINARY_DIR}/include)
#FIXME maybe better to move this part to an helper function 
foreach (in_h ${ks_headers})
  get_filename_component(in_h_basename ${in_h} NAME_WE)
  set (out_h "${ks_include_dir}/${in_h_basename}.fh")
  qe_preprocess_source("${CMAKE_CURRENT_SOURCE_DIR}/${in_h}" ${out_h})
  list (APPEND ks_out_headers ${out_h})
endforeach()
add_custom_target(qe_ks_headers 
  DEPENDS ${ks_out_headers}
  VERBATIM )

set(src_davidson
    Davidson_RCI/david_rci.f90
    Davidson/cegterg.f90
    Davidson/regterg.f90
    # GPU
    Davidson/regterg_gpu.f90
    Davidson/cegterg_gpu.f90)
qe_enable_cuda_fortran("${src_davidson}")

set(src_davidson_rci
    Davidson_RCI/david_rci.f90)

set(src_cg
    CG/ccgdiagg.f90
    CG/rcgdiagg.f90
    # GPU
    CG/rcgdiagg_gpu.f90
    CG/ccgdiagg_gpu.f90)
qe_enable_cuda_fortran("${src_cg}")

set(src_ppcg
    PPCG/ppcg_gamma.f90
    PPCG/ppcg_k.f90
    # GPU
    PPCG/ppcg_gamma_gpu.f90
    PPCG/ppcg_k_gpu.f90
    PPCG/generic_cublas.f90)
qe_enable_cuda_fortran("${src_ppcg}")

set(src_dense
    DENSE/rotate_HSpsi_gamma.f90
    DENSE/rotate_HSpsi_k.f90
    DENSE/rotate_wfc_gamma.f90
    DENSE/rotate_wfc_k.f90 
    DENSE/rotate_xpsi_k.f90
    DENSE/rotate_xpsi_gamma.f90
    DENSE/gram_schmidt_k.f90
    DENSE/gram_schmidt_gamma.f90
    DENSE/rotate_driver.f90
    # GPU
    DENSE/rotate_wfc_gamma_gpu.f90
    DENSE/rotate_xpsi_k_gpu.f90
    DENSE/rotate_xpsi_gamma_gpu.f90
    DENSE/gram_schmidt_k_gpu.f90
    DENSE/gram_schmidt_gamma_gpu.f90
    DENSE/rotate_wfc_k_gpu.f90
    DENSE/rotate_driver_cuf.f90)
qe_enable_cuda_fortran("${src_dense}")

set(src_paro
    ParO/bpcg_gamma.f90
    ParO/bpcg_k.f90
    ParO/paro_gamma.f90
    ParO/pcg_gamma.f90
    ParO/paro_k.f90
    ParO/pcg_k.f90
    ParO/paro_gamma_new.f90
    ParO/paro_k_new.f90)
qe_enable_cuda_fortran("${src_paro}")

set(src_rmmdiis
    RMM/crmmdiagg.f90 
    RMM/rrmmdiagg.f90 
    # GPU
    RMM/crmmdiagg_gpu.f90
    RMM/rrmmdiagg_gpu.f90)
    qe_enable_cuda_fortran("${src_rmmdiis}")

qe_add_library(qe_kssolver_davidson ${src_davidson})
target_link_libraries(qe_kssolver_davidson
    PRIVATE
        qe_device_lapack
        qe_openacc_fortran
        qe_openmp_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)

qe_add_library(qe_kssolver_davidsonrci ${src_davidson_rci})
target_link_libraries(qe_kssolver_davidsonrci
    PRIVATE
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_cg ${src_cg})
target_link_libraries(qe_kssolver_cg
    PRIVATE
        qe_lax
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)

qe_add_library(qe_kssolver_ppcg ${src_ppcg})
target_link_libraries(qe_kssolver_ppcg
    PRIVATE
        qe_scalapack
        qe_openmp_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_dense ${src_dense})
target_link_libraries(qe_kssolver_dense
    PRIVATE
        qe_openacc_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)
target_include_directories(qe_kssolver_dense
  PUBLIC
    $<BUILD_INTERFACE:${ks_include_dir}>
    $<INSTALL_INTERFACE:include/qe>
)
set_target_properties(qe_kssolver_dense
  PROPERTIES PUBLIC_HEADER ${ks_out_headers}
)
add_dependencies(qe_kssolver_dense qe_ks_headers)

qe_add_library(qe_kssolver_paro ${src_paro})
target_link_libraries(qe_kssolver_paro
    PRIVATE 
        qe_device_lapack
        qe_openacc_fortran
        qe_kssolver_dense
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_rmmdiis ${src_rmmdiis})
target_link_libraries(qe_kssolver_rmmdiis
    PRIVATE
	qe_lax
        qe_utilx
	qe_devxlib
        qe_mpi_fortran )  

###########################################################

qe_install_targets(
    qe_kssolver_davidson
    qe_kssolver_davidsonrci
    qe_kssolver_cg
    qe_kssolver_ppcg
    qe_kssolver_paro
    qe_kssolver_dense
    qe_kssolver_rmmdiis)

=== LAXlib/Makefile ===
# Makefile for LAXlib

include ../make.inc


EXTLIBS=$(CUDA_LIBS) $(SCALAPACK_LIBS) $(LAPACK_LIBS) $(BLAS_LIBS) $(MPI_LIBS)


LAX = la_types.o \
la_error.o \
la_module.o \
la_helper.o \
cdiaghg.o \
rdiaghg.o \
dspev_drv.o \
ptoolkit.o \
transto.o \
distools.o \
zhpev_drv.o \
mp_diag.o \
la_param.o


all : libqela.a


libqela.a:  $(LAX)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

la_test.x : test.o libqela.a 
	$(LD) $(LDFLAGS) -o la_test.x test.o libqela.a $(EXTLIBS)

TEST : la_test.x

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L *.x *.fh

$(LAX) : laxlib.fh  laxlib_hi.fh  laxlib_kinds.fh  laxlib_low.fh  laxlib_mid.fh  laxlib_param.fh

include make.depend

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=quantum-espresso
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=7.3.1
pkgrel=1
_d3q_commit=87685245bc5bc14f226fc18e5126305501b368e8
_devxlib_commit=a6b89ef77b1ceda48e967921f1f5488d2df9226d
_fox_commit=3453648e6837658b747b895bb7bef4b1ed2eac40
_pw2qmcpack_commit=f72ab25fa4ea755c1b4b230ae8074b47d5509c70
_qe_gipaw_commit=75b01b694c9ba4df55d294cacc27cf28591b2161
pkgdesc="opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='http://www.quantum-espresso.org/'
msys2_repository_url="https://gitlab.com/QEF/q-e"
msys2_references=(
  'aur: quantum-espresso'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libmbd"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-wannier90"
             #"${MINGW_PACKAGE_PREFIX}-environ"
             "git")
source=("https://gitlab.com/QEF/q-e/-/archive/qe-${pkgver}/q-e-qe-${pkgver}.tar.bz2"
        #"d3q::git+https://github.com/anharmonic/d3q#commit=${_d3q_commit}"
        "devxlib::git+https://gitlab.com/max-centre/components/devicexlib#commit=${_devxlib_commit}"
        "fox::git+https://github.com/pietrodelugas/fox#commit=${_fox_commit}"
        "pw2qmcpack::git+https://github.com/QMCPACK/pw2qmcpack#commit=${_pw2qmcpack_commit}"
        #"qe-gipaw::git+https://github.com/dceresoli/qe-gipaw#commit=${_qe_gipaw_commit}"
        "001-use-srand-instead-of-srandom.patch"
        "002-fix-build-devxlib-on-mingw.patch"
        "003-fix-install-c-libraries.patch"
        "004-fix-executable-suffix-on-mingw.patch")
sha256sums=('4955e4ca5e47a0faafefc72442155bef02ff94c8b796698ad81d4804a1cf6d88'
            'ef02c13a1ea73f38f0b81edd281c991c25bf045307ceb305f5c0f96b743d1556'
            '8625181b53f2b616a0f704507b4f2381f7b9fabe02078dfb74ab41ee11f5c260'
            'f0f5ebece3f0142e0d0b476db9547d8501de80259bc6409e9b108b887e4cc058'
            '2e18a13c194328516176c2bc2429ac230c9fc585381aa238e586b6034a7df0cb'
            'faaf147678e0c79a6678c5463dd5a466769257968275ef562f40ad1a0c2aacc6'
            '8620f943efd69971a1ca9cd3f0bfe35a1f73a771bf30b1b3516bf74d9a2ca702'
            '7ce3be146fca1868ad94f2fc7c91ad767e3ce359eadbaf0c3d275290c3fd16f0')
noextract=("q-e-qe-${pkgver}.tar.bz2")

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  echo "Extracting q-e-qe-${pkgver}.tar.bz2..."
  tar -xjf q-e-qe-${pkgver}.tar.bz2 || true

  for _ext_prj in devxlib fox pw2qmcpack; do
    mv ${_ext_prj} q-e-qe-${pkgver}/external/
  done

  cd "${srcdir}"/q-e-qe-${pkgver}
  apply_patch_with_msg \
    001-use-srand-instead-of-srandom.patch \
    002-fix-build-devxlib-on-mingw.patch \
    003-fix-install-c-libraries.patch \
    004-fix-executable-suffix-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS=" -Wno-missing-include-dirs -w"
  fi

  CFLAGS+=" -Wno-incompatible-pointer-types" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DQE_ENABLE_FOX=ON \
      -DQE_ENABLE_HDF5=ON \
      -DQE_ENABLE_OPENMP=ON \
      -DQE_ENABLE_ENVIRON=OFF \
      -DQE_ENABLE_LIBXC=OFF \
      -DQE_ENABLE_MPI=OFF \
      -DQE_ENABLE_TEST=OFF \
      -DQE_ENABLE_PLUGINS="pw2qmcpack;legacy" \
      -DQE_DEVICEXLIB_INTERNAL=ON \
      -DQE_FOX_INTERNAL=ON \
      -DQE_MBD_INTERNAL=OFF \
      -DQE_WANNIER90_INTERNAL=OFF \
      -DQE_FFTW_VENDOR="FFTW3" \
      -DBLA_VENDOR=OpenBLAS \
      -S q-e-qe-${pkgver} \
      -B build-${MSYSTEM}

  "${MINGW_PREFIX}"/bin/cmake.exe --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/q-e-qe-${pkgver}/License \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/qe/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done
}
